/*
2次形式：2x^2 + 2y^2 + 2z^2 + 2xy + 2yz + 2zx = 3 
の標準形を求めよう

 */

#include <kvs/Vector3>
#include <kvs/Matrix33>

int main( int argc, char** argv )
{
  // 2次形式を行列とベクトルで表したとき行列 A は以下のようになる 
  kvs::Matrix33d A( 2.0, 1.0, 1.0,
		    1.0, 2.0, 1.0,
		    1.0, 1.0, 2.0 ); 

  // Aの固有ベクトル
  kvs::Vector3d p1 ( 1.0/sqrt(2.0), -1.0/sqrt(2.0),       0.0 );
  kvs::Vector3d p2 ( 1.0/sqrt(6.0),  1.0/sqrt(6.0), -2.0/sqrt(6.0) );
  kvs::Vector3d p3 ( 1.0/sqrt(3.0),  1.0/sqrt(3.0),  1.0/sqrt(3.0) );
  // 直交行列
  kvs::Matrix33d P  ( p1.x(), p2.x(), p3.x(),
		      p1.y(), p2.y(), p3.y(),
		      p1.z(), p2.z(), p3.z() );
  // ベクトルの内積
  std::cout << p1.dot(p2) << std::endl;
  
  kvs::Matrix33d L = P.transposed() * A * P;
  std::cout << L << std::endl;
  std::cout << L[0][0] << " X^2 + " << L[1][1] << " Y^2 + " << L[2][2] << " Z^2 = 3 " << std::endl;

  return ( 0 );

}
